// FICHIER : PoutSfe3.cc
// CLASSE : PoutSfe3

//#include "Debug.h"

# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
#include "FrontSegLine.h"
#include "FrontTriaLine.h"


#include "PoutSfe3.h"
//----------------------------------------------------------------
// def des donnees commune a tous les elements
// la taille n'est pas defini ici car elle depend de la lecture 
//----------------------------------------------------------------
SfeMembT::DonnComSfe * PoutSfe3::doCoSfe3 = NULL;
SfeMembT::UneFois  PoutSfe3::uneFoisSfe3;
PoutSfe3::NombresConstruirePoutSfe3 PoutSfe3::nombre_V;
PoutSfe3::ConsPoutSfe3 PoutSfe3::consPoutSfe3;

// constructeur définissant les nombres (de noeud, de point d'integ ..)
// utilisé dans la construction des éléments
PoutSfe3::NombresConstruirePoutSfe3::NombresConstruirePoutSfe3()
 { nbnce = 3; // nb de noeud de l'element central
   nbnte = 6; // nombre total de noeud
   nbneA = 2; // le nombre de noeud des aretes de l'élément central
   nbis  = 1;  // le nombre de point d'intégration de surface pour le calcul mécanique
   nbie  = 2;  // nombre de pt d'integ d'epaisseur pour le calcul mécanique
   nbisEr= 3; // le nombre de point d'intégration de surface pour le calcul d'erreur
   nbieEr= 2; // le nombre de point d'intégration d'épaisseur pour le calcul d'erreur
   nbiSur= 3; // le nombre de point d'intégration pour le calcul de second membre surfacique
   nbiA  = 1; // le nombre de point d'intégration pour le calcul de second membre linéique
   nbisMas = 3; // le nombre de point d'intégration de surface pour le calcul de la matrice masse 
   nbieMas = 2; // le nombre de point d'intégration d'épaisseur pour le calcul de la matrice masse 
  }; 
// =========================== constructeurs ==================

PoutSfe3::PoutSfe3 () :
  SfeMembT()
// Constructeur par defaut
{// on intervient seulement à partir du deuxième élément, 
 if (uneFoisSfe3.nbelem_in_Prog == 0)
   { uneFoisSfe3.nbelem_in_Prog++; // au premier passage on se contente d'incrémenter
    }
 else 	// sinon on construit     
  {nombre = & nombre_V; 
   id_interpol = SFE3;
   id_geom = POUT;
   tab_noeud.Change_taille(nombre->nbnte);
   int dim = ParaGlob::Dimension();
   ElemGeomC0* eleCentre=NULL,* eleEr=NULL,* eleS=NULL,* eleMas=NULL;
   if ( doCoSfe3 == NULL)  
      {eleCentre = new GeomTriangle (nombre->nbis,nombre->nbnce);
       eleEr = new GeomTriangle(nombre->nbisEr,nombre->nbnce);
       eleS = new GeomTriangle(nombre->nbiSur,nombre->nbnce);
       eleMas = new GeomTriangle(nombre->nbisMas,nombre->nbnce);
       };
   
   if (dim != 3)  // cas d'une dimension autre que trois
	 { if (ParaGlob::NiveauImpression() >= 7)
	     cout << "\nATTENTION -> dimension " << dim 
	          <<", pas de definition Pout Sfe3 "<< endl;
       delete eleCentre; delete eleEr; delete eleS; delete eleMas;
	   unefois = NULL;
	  }	  
   else 
     // calcul de doCoSfe3 egalement si c'est le premier passage
    { unefois = & uneFoisSfe3; // affectation du pointeur de la classe générique triangle
      doCoSfe3 = SfeMembT::Init(eleCentre,eleEr,eleS,eleMas); // initialisation par défaut
      unefois->nbelem_in_Prog++;
     } 
  };
};  
	
PoutSfe3::PoutSfe3 (double epaiss,int num_mail,int num_id):
// Constructeur utile si la section de l'element et
// le numero de l'element  sont connus
       SfeMembT(num_mail,num_id,SFE3,POUT)
{// on intervient seulement à partir du deuxième élément, 
 if (uneFoisSfe3.nbelem_in_Prog == 0)
   { uneFoisSfe3.nbelem_in_Prog++; // au premier passage on se contente d'incrémenter
    }
 else 	// sinon on construit     
  {nombre = & nombre_V; 
   tab_noeud.Change_taille(nombre->nbnte);
   ElemGeomC0* eleCentre=NULL,* eleEr=NULL,* eleS=NULL,* eleMas=NULL;
   if ( doCoSfe3 == NULL)  
      {eleCentre = new GeomTriangle (nombre->nbis,nombre->nbnce);
       eleEr = new GeomTriangle(nombre->nbisEr,nombre->nbnce);
       eleS = new GeomTriangle(nombre->nbiSur,nombre->nbnce);
       eleMas = new GeomTriangle(nombre->nbisMas,nombre->nbnce);
       };
   
   if (ParaGlob::Dimension() != 3) // cas d'une dimension autre que trois
      {cout << "\n erreur de dimension dans PoutSfe3 , dim = " << ParaGlob::Dimension()
              << "\n alors que l'on doit avoir  3 !! " << endl;
       delete eleCentre; delete eleEr; delete eleS; delete eleMas;
       Sortie (1);
      };        
     // calcul de doCoSfe3 egalement si c'est le premier passage
    { unefois = & uneFoisSfe3; // affectation du pointeur de la classe générique triangle
      int type_calcul_jacobien = 1; // facette plane
      doCoSfe3 = SfeMembT::Init(eleCentre,eleEr,eleS,eleMas
                                ,type_calcul_jacobien,Donnee_specif(epaiss));
      unefois->nbelem_in_Prog++;
    } 	
  };
};  

// Constructeur fonction  d'un numero de maillage et d'identification  
PoutSfe3::PoutSfe3 (int num_mail,int num_id) :
  SfeMembT(num_mail,num_id,SFE3,POUT)
{// on intervient seulement à partir du deuxième élément, 
 if (uneFoisSfe3.nbelem_in_Prog == 0)
   { uneFoisSfe3.nbelem_in_Prog++; // au premier passage on se contente d'incrémenter
    }
 else 	// sinon on construit     
  {nombre = & nombre_V; 
   tab_noeud.Change_taille(nombre->nbnte);
   ElemGeomC0* eleCentre=NULL,* eleEr=NULL,* eleS=NULL,* eleMas=NULL;
   if ( doCoSfe3 == NULL)  
      {eleCentre = new GeomTriangle (nombre->nbis,nombre->nbnce);
       eleEr = new GeomTriangle(nombre->nbisEr,nombre->nbnce);
       eleS = new GeomTriangle(nombre->nbiSur,nombre->nbnce);
       eleMas = new GeomTriangle(nombre->nbisMas,nombre->nbnce);
       };
   
   if (ParaGlob::Dimension() != 3) // cas d'une dimension autre que trois
      {cout << "\n erreur de dimension dans PoutSfe3 , dim = " << ParaGlob::Dimension()
              << "\n alors que l'on doit avoir  3 !! " << endl;
       delete eleCentre; delete eleEr; delete eleS; delete eleMas;
       Sortie (1);
      };        
     // calcul de doCoSfe3 egalement si c'est le premier passage
    { unefois = & uneFoisSfe3; // affectation du pointeur de la classe générique triangle
      doCoSfe3 = SfeMembT::Init(eleCentre,eleEr,eleS,eleMas); // intialisation par defaut
      unefois->nbelem_in_Prog++;
     } 
  };
};  

// Constructeur utile si l'epaisseur de l'element, le numero de l'element et
// le tableau des noeuds sont connus
PoutSfe3::PoutSfe3 (double epaiss,int num_mail,int num_id,const Tableau<Noeud *>& tab):
    SfeMembT(num_mail,num_id,SFE3,POUT,tab)
{// on intervient seulement à partir du deuxième élément, 
 if (uneFoisSfe3.nbelem_in_Prog == 0)
   { uneFoisSfe3.nbelem_in_Prog++; // au premier passage on se contente d'incrémenter
    }
 else 	// sinon on construit     
  {nombre = & nombre_V; 
   if (tab_noeud.Taille() != nombre->nbnte)
	  { cout << "\n erreur de dimensionnement du tableau de noeud \n";
	   cout << " PoutSfe3::PoutSfe3 (double epaiss,int num_mail,int num_mail,int num_id,const Tableau<Noeud *>& tab)\n";
	   Sortie (1); }
   ElemGeomC0* eleCentre=NULL,* eleEr=NULL,* eleS=NULL,* eleMas=NULL;
   if ( doCoSfe3 == NULL)  
      {eleCentre = new GeomTriangle (nombre->nbis,nombre->nbnce);
       eleEr = new GeomTriangle(nombre->nbisEr,nombre->nbnce);
       eleS = new GeomTriangle(nombre->nbiSur,nombre->nbnce);
       eleMas = new GeomTriangle(nombre->nbisMas,nombre->nbnce);
       };
   
   if (ParaGlob::Dimension() != 3) // cas d'une dimension autre que trois
      {cout << "\n erreur de dimension dans PoutSfe3 , dim = " << ParaGlob::Dimension()
              << "\n alors que l'on doit avoir  3 !! " << endl;
       delete eleCentre; delete eleEr; delete eleS; delete eleMas;
       Sortie (1);
      };        
     // calcul de doCoSfe3 egalement si c'est le premier passage
    { unefois = & uneFoisSfe3; // affectation du pointeur de la classe générique triangle
      bool sans_init_noeud = true;
      int type_calcul_jacobien = 1; // facette plane
      doCoSfe3 = SfeMembT::Init(eleCentre,eleEr,eleS,eleMas
                                ,type_calcul_jacobien,Donnee_specif(epaiss),sans_init_noeud);
      // construction du tableau de ddl spécifique à l'élément pour ses 
      ConstTabDdl(); 
      unefois->nbelem_in_Prog++;
     } 
  };
};  

// Constructeur de copie
PoutSfe3::PoutSfe3 (const PoutSfe3& PoutM) :
 SfeMembT (PoutM)
// a priori si on utilise le constructeur de copie, donc il y a déjà un élément
// par contre a priori on ne doit pas faire une copie du premier élément 
{ if (uneFoisSfe3.nbelem_in_Prog == 1)
   { cout << "\n **** erreur pour l'element PoutSfe3, le constructeur de copie ne doit pas etre utilise"
	       << " pour le premier element !! " << endl;
	  Sortie (1);
    }
 else 	    
  {if (ParaGlob::Dimension() != 3) // cas d'une dimension autre que trois
      {cout << "\n erreur de dimension dans PoutSfe3 , dim = " << ParaGlob::Dimension()
              << "\n alors que l'on doit avoir  3 !! " << endl;
       Sortie (1);
      };        
   unefois = & uneFoisSfe3; // affectation du pointeur de la classe générique triangle
   // ce qui est relatif à l'initialisation est déjà effectué dans elem_meca et SfeMembT
   unefois->nbelem_in_Prog++;
	};
};	

PoutSfe3::~PoutSfe3 ()
// Destruction effectuee dans SfeMembT
{ if (unefois != NULL) 
    {unefois->nbelem_in_Prog--;
     Destruction();
     }
};
                         
// affichage dans la sortie transmise, des variables duales "nom"
// aux differents points d'integration
// dans le cas ou nom est vide, affichage de "toute" les variables
void PoutSfe3::AfficheVarDual(ofstream& sort, Tableau<string>& nom)
  { // affichage de l'entête de l'element
    sort << "\n**************************************************************************************";
    sort << "\n Element PoutSfe3 (poutre SFE3 2 pt d'integration dans l'epaisseur et 1 de surface) ";
    sort << "\n**************************************************************************************";
    // appel de la procedure de elem meca
    if (!(unefois->dualSortSfe) && (unefois->CalimpPrem))
        { VarDualSort(sort,nom,1,1);
          unefois->dualSortSfe += 1;
         } 
    else if ((unefois->dualSortSfe) && (unefois->CalimpPrem))       
         VarDualSort(sort,nom,3,11);
    else if (!(unefois->dualSortSfe) && (unefois->CalResPrem_tdt))       
        { VarDualSort(sort,nom,1,2);
          unefois->dualSortSfe += 1;
         }         
    else if ((unefois->dualSortSfe) && (unefois->CalResPrem_tdt))       
         VarDualSort(sort,nom,1,12);
      // sinon on ne fait rien     
  };               	
   
