// FICHIER Enum_StabHourglass.cc


// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.


#include "Enum_StabHourglass.h"


# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
//#ifdef SYSTEM_MAC_OS_X
//  #include <stringfwd.h> // a priori ce n'est pas portable
//#el
#if defined  SYSTEM_MAC_OS_CARBON
  #include <stringfwd.h> // a priori ce n'est pas portable
#else  
  #include <string.h> // pour le flot en memoire centrale
#endif
#include <string>


// Retourne le nom a partir de son identificateur de type enumere 
string Nom_StabHourglass (Enum_StabHourglass id_nom)
{
	
	string result="";
	switch (id_nom)
	{
		case STABHOURGLASS_NON_DEFINIE : 
			result="STABHOURGLASS_NON_DEFINIE";
			break;
		case STABHOURGLASS_PAR_COMPORTEMENT :
			result="STABHOURGLASS_PAR_COMPORTEMENT";
			break;
		case STABHOURGLASS_PAR_COMPORTEMENT_REDUIT :
			result="STABHOURGLASS_PAR_COMPORTEMENT_REDUIT";
			break;
		default :
			cout << "\nErreur : valeur incorrecte du type Enum_StabHourglass !\n";
			cout << "Nom_StabHourglass(Enum_StabHourglass ) \n";
			Sortie(1);
	};
	return result;
	
};

Enum_StabHourglass  Id_Nom_StabHourglass (const char* nom_StabHourglass) 
// Retourne la variable de type enumere associee au nom 
{
	
	Enum_StabHourglass result;
	if ( strcmp(nom_StabHourglass,"STABHOURGLASS_NON_DEFINIE")==0 )
		result=STABHOURGLASS_NON_DEFINIE;
	else if ( strcmp(nom_StabHourglass,"STABHOURGLASS_PAR_COMPORTEMENT")==0 )
		result=STABHOURGLASS_PAR_COMPORTEMENT;
	else if ( strcmp(nom_StabHourglass,"STABHOURGLASS_PAR_COMPORTEMENT_REDUIT")==0 )
		result=STABHOURGLASS_PAR_COMPORTEMENT_REDUIT;
    else
	{
		cout << "\nErreur : nom " << nom_StabHourglass << " du type de stabilisation d'hourglass inconnue !\n";
		cout << "Id_nom_StabHourglass (char* nom) \n";
		Sortie(1);
	};
	return result;
	
};	


// Retourne vrai si le nom passé en argument représente un type reconnu
// sinon false
bool Type_Enum_StabHourglass_existe(const string& nom)
{ bool result;
	if ( nom == "STABHOURGLASS_PAR_COMPORTEMENT") {result=true;}
	else if ( nom == "STABHOURGLASS_PAR_COMPORTEMENT_REDUIT") {result=true;}
	else if (  nom == "STABHOURGLASS_NON_DEFINIE") {result=true;}
	else {result = false;}
	return result;
};
   	
   // surcharge de l'operator de lecture
istream & operator >> (istream & entree, Enum_StabHourglass& a)
 { char nom_Enum_StabHourglass[50];
   entree >> nom_Enum_StabHourglass;
   a = Id_Nom_StabHourglass ( nom_Enum_StabHourglass);
   return entree;
 };
   
   // surcharge de l'operator d'ecriture
ostream & operator << (ostream & sort, const Enum_StabHourglass& a)
    { // on ecrit la forme caractère
       sort << Nom_StabHourglass(a) << " ";
       return sort;      
     }; 






