/*! \file Enum_crista.h
    \brief def Enumération des différents calcul de cristalinité
* \date      04/03/2008
*/

// FICHIER : Enum_crista.h

// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

/************************************************************************
 *     DATE:        04/03/2008                                          *
 *                                                                $     *
 *     AUTEUR:      G RIO   (mailto:gerardrio56@free.fr)                *
 *                                                                $     *
 *     PROJET:      Herezh++                                            *
 *                                                                $     *
 ************************************************************************
 *     BUT:  Enumération des différents calcul de cristalinité          *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *                                                                      *
 *     VERIFICATION:                                                    *
 *                                                                      *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *     !        !            !                                    !     *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *
 *     MODIFICATIONS:                                                   *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *                                                                $     *
 ************************************************************************/
 
#ifndef ENUM_CRISTA_H
#define ENUM_CRISTA_H

#include <iostream>
using namespace std;

/// @addtogroup Group_types_enumeres
///  @{

/// Enumération des différents calcul de cristalinité

enum Enum_crista { HOFFMAN = 1,HOFFMAN2, CRISTA_PAS_DEFINI };
const int nombre_maxi_de_type_de_Enum_crista = 2;
/// @}  // end of group




// Retourne un nom de type de Enum_crista a partir de son identificateur de
// type enumere id_Enum_crista correspondant
char* Nom_Enum_crista (Enum_crista id_Enum_crista);

// Retourne l'identificateur de type enumere associe au nom du type
// de Enum_crista nom_Enum_crista
Enum_crista Id_nom_Enum_crista (const char* nom_Enum_crista) ;

// surcharge de l'operator de lecture
istream & operator >> (istream & entree, Enum_crista& a);  
// surcharge de l'operator d'ecriture
ostream & operator << (ostream & sort, const Enum_crista& a);


#endif


