// FICHIER Enum_proj_aniso.cc

// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.



#include "Enum_proj_aniso.h"


# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
//#ifdef SYSTEM_MAC_OS_X
//  #include <stringfwd.h> // a priori ce n'est pas portable
//#el
#if defined  SYSTEM_MAC_OS_CARBON
  #include <stringfwd.h> // a priori ce n'est pas portable
#else  
  #include <string.h> // pour le flot en memoire centrale
#endif
#include <string>


// Retourne le nom a partir de son identificateur de type enumere 
string Nom_proj_aniso (Enum_proj_aniso id_nom)
{string result="";
	switch (id_nom)
	{
		case AUCUNE_PROJ_ANISO :
			result="AUCUNE_PROJ_ANISO";
			break;
		case PROJ_ORTHO :
			result="PROJ_ORTHO";
			break;
		default :
			cout << "\nErreur : valeur incorrecte du type Enum_proj_aniso !\n";
			cout << "Nom_proj_aniso(Enum_proj_aniso ) \n";
			Sortie(1);
	};
	return result;
	
};

Enum_proj_aniso  Id_Nom_proj_aniso (const string& nom_proj_aniso)
// Retourne la variable de type enumere associee au nom 
{
	
	Enum_proj_aniso result;
	if ( nom_proj_aniso == "AUCUNE_PROJ_ANISO" )
		result=AUCUNE_PROJ_ANISO;
	else if ( nom_proj_aniso == "PROJ_ORTHO")
		result=PROJ_ORTHO;
 else
  {
   cout << "\nErreur : nom " << nom_proj_aniso << " type de critere de loi inconnue !\n";
   cout << "Id_Nom_proj_aniso (const string& nom_proj_aniso) \n";
   Sortie(1);
  };
	return result;
	
};	


// Retourne vrai si le nom passé en argument représente un type reconnu
// sinon false
bool Type_Enum_proj_aniso_existe(const string& nom)
{ bool result;
	if ( nom == "PROJ_ORTHO") {result=true;}
	else if (  nom == "AUCUNE_PROJ_ANISO") {result=true;}
	else {result = false;}
	return result;
};
   	
   // surcharge de l'operator de lecture
istream & operator >> (istream & entree, Enum_proj_aniso& a)
   { string nom_Enum_proj_aniso;
     entree >> nom_Enum_proj_aniso;
     a = Id_Nom_proj_aniso ( nom_Enum_proj_aniso);
     return entree;
   };

   // surcharge de l'operator d'ecriture
ostream & operator << (ostream & sort, const Enum_proj_aniso& a)
   { // on ecrit la forme caractère
      sort << Nom_proj_aniso(a) << " ";
      return sort;      
   };






