
// FICHIER Enum_type_stocke_deformation.cc


// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.


#include "Enum_type_stocke_deformation.h"


# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
//#ifdef SYSTEM_MAC_OS_X
//  #include <stringfwd.h> // a priori ce n'est pas portable
//#el
#if defined  SYSTEM_MAC_OS_CARBON
  #include <stringfwd.h> // a priori ce n'est pas portable
#else  
  #include <string.h> // pour le flot en memoire centrale
#endif
#include <string>


#ifndef  Enum_type_stocke_deformation_deja_inclus

#ifndef MISE_AU_POINT
  inline 
#endif
char* Nom_type_stockage_def (Enum_type_stocke_deformation id_nom)
// Retourne le nom du type associe
// a l'identificateur de type enumere id_nom
{
	
	char* result="";
	switch (id_nom)
	{
		case SAVEDEFRESUL_GENERAL : 
			result="SAVEDEFRESUL_GENERAL";
			break;
		case SAVEDEFRESUL_SFE1 :
			result="SAVEDEFRESUL_SFE1";
			break;
		default :
			cout << "\nErreur : valeur incorrecte du type Enum_type_stocke_deformation !\n";
			cout << "Nom_dure(Enum_type_stocke_deformation ) \n";
			Sortie(1);
	};
	return result;
	
};

#ifndef MISE_AU_POINT
  inline 
#endif
Enum_type_stocke_deformation  Id_nom_type_stockage_def (char* nom)
// Retourne la variable de type enumere associee au nom du type
{
	
	Enum_type_stocke_deformation result;
	if ( strcmp(nom,"SAVEDEFRESUL_GENERAL")==0 )
		result=SAVEDEFRESUL_GENERAL;
	else if ( strcmp(nom,"SAVEDEFRESUL_SFE1")==0 )
		result=SAVEDEFRESUL_SFE1;
    else
	{
		cout << "\nErreur : nom du degre de liberte inconnu !\n";
		cout << "Id_nom_dure (char* nom) \n";
		Sortie(1);
	};
	return result;
	
};	

   	
   // surcharge de l'operator de lecture
#ifndef MISE_AU_POINT
  inline 
#endif
istream & operator >> (istream & entree, Enum_type_stocke_deformation& a)
 { char nom_Enum_type_stocke_deformation[50];
   entree >> nom_Enum_type_stocke_deformation;
   a = Id_nom_type_stockage_def ( nom_Enum_type_stocke_deformation);
   return entree;
 };
   
   // surcharge de l'operator d'ecriture
#ifndef MISE_AU_POINT
  inline 
#endif
ostream & operator << (ostream & sort, const Enum_type_stocke_deformation& a)
    { // on ecrit la forme caractère
       sort << Nom_type_stockage_def(a) << " ";
       return sort;      
     }; 

#endif





