/*! \file MotCle.h
    \brief def Enumeration des differents mot cle dans le fichier d'entree.
* \date      23/01/97
*/

// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

/************************************************************************
 *     DATE:        23/01/97                                            *
 *                                                                $     *
 *     AUTEUR:      G RIO   (mailto:gerardrio56@free.fr)                *
 *                                                                $     *
 *     PROJET:      Herezh++                                            *
 *                                                                $     *
 ************************************************************************
 *     BUT: Enumeration des differents mot cle dans le fichier d'entree.*
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *                                                                      *
 *     VERIFICATION:                                                    *
 *                                                                      *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *     !        !            !                                    !     *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *
 *     MODIFICATIONS:                                                   *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *                                                                $     *
 ************************************************************************/
#ifndef ENUM_MOTCLE_H
#define ENUM_MOTCLE_H

#include <iostream>
using namespace std;
// #include "bool.h"
#include "Tableau_T.h"
#include "Constante.h"
#include <list>

/// @addtogroup Group_types_enumeres
///  @{
  
/// ici l'énuméré est remplacé par une classe

class MotCle
{
  public :
    // VARIABLES PUBLIQUES :

        
    // CONSTRUCTEURS :
    MotCle ( const Tableau<string>& TsousMot = tab_Zero_string );
    // DESTRUCTEUR :
    ~MotCle () {};
    // METHODES PUBLIQUES :
    
    /// retourne true s'il y a un mot cle dans la chaine de character
    /// false sinon
    bool SimotCle(char* tabcar);
    
  private :  
    // VARIABLES PROTEGEES :
    list <string> lesmotscles; // liste des mots clés
    Tableau <string> tabSous; 
    int TabSous_taille; 
    int lesmotscles_taille;
    list <string>::iterator itdeb,itfin,it;    
 };
 /// @}  // end of group

 
#endif  
