
// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

/************************************************************************
 *     DATE:        23/01/97                                            *
 *                                                                $     *
 *     AUTEUR:      G RIO   (mailto:gerardrio56@free.fr)                *
 *                                                                $     *
 *     PROJET:      Herezh++                                            *
 *                                                                $     *
 ************************************************************************
 *     BUT:  Class  pour la lecture d'une reference et d'un tableau de  *
 *           string devant appartenir a une liste identifie.            *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *                                                                      *
 *     VERIFICATION:                                                    *
 *                                                                      *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *     !        !            !                                    !     *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *
 *     MODIFICATIONS:                                                   *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *                                                                $     *
 ************************************************************************/
#ifndef LECTBLOCMOT_H
#define LECTBLOCMOT_H

#include <iostream>
#include <stdlib.h>
#include "Sortie.h"
#include "UtilLecture.h"
#include "LesReferences.h"
#include "string"
#include "MotCle.h"
#include <list>
#include "string.h"
#include "Tableau_T.h"
#include "Constante.h"
#include "Bloc.h"
#include "CharUtil.h"
#include "BlocDdlLim.h"


/// @addtogroup Goupe_relatif_aux_entrees_sorties
///  @{
///


class LectBlocmot
{
  public :
    // CONSTRUCTEURS :
    LectBlocmot () {};
    // DESTRUCTEUR :
    ~LectBlocmot () {};
    // METHODES PUBLIQUES :
    
    // lecture d'un bloc de mot
    
    // blocMot : contiend la ref lue et la liste des mots lue
    // entreePrinc : stream de lecture ( sur le fichier d'entree)
    // lesRef : liste des references generale lue
    // message : a afficher en cas d'erreur
    // tabMot  : contiend  la liste des mots acceptable pour la lecture
    // TsousMot : tableau de sous mot cle permetant l'arret de la lecture
    //
    // la lecture s'arretera lorsque l'on aura trouve soit un mot cle ou soit un sous mot cle
    
    BlocDdlLim< BlocGen>  Lecture(UtilLecture & entreePrinc,LesReferences& lesRef,string message,
                            Tableau<string>& tabMot,Tableau<string>& TsousMot);
                 
    
  private :  
    // VARIABLES PROTEGEES :
    // METHODES PROTEGEES :

 };
   /// @}  // end of group

#endif  
