// FICHIER : Ddl_etendu.cp
// CLASSE : Ddl_etendu


// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.


#include "Ddl_etendu.h"


# include <iostream>
using namespace std;  //introduces namespace std

#include <stdlib.h>
#include "Sortie.h"
	  
#ifndef  Ddl_etendu_deja_inclus

#ifndef MISE_AU_POINT
  inline 
#endif
// Constructeur  par défaut
Ddl_etendu::Ddl_etendu () :
    ddl_enum_etendu(), val_ddl(0.0) 
       {};

#ifndef MISE_AU_POINT
  inline 
#endif
// Constructeur fonction des variables
Ddl_etendu::Ddl_etendu (const Ddl_enum_etendu& ddl,double vale) :
   ddl_enum_etendu(ddl), val_ddl(vale) 
		     {};

#ifndef MISE_AU_POINT
  inline 
#endif
// Constructeur de copie
Ddl_etendu::Ddl_etendu (const Ddl_etendu& d):
  ddl_enum_etendu(d.ddl_enum_etendu),val_ddl(d.val_ddl)
   {};

#ifndef MISE_AU_POINT
  inline 
#endif
Ddl_etendu::~Ddl_etendu ()
// Destructeur
{ };


#ifndef MISE_AU_POINT
  inline 
#endif
// surcharge de l'operateur d'ecriture
ostream &  operator << (ostream & sort,const  Ddl_etendu & a)
  { // écriture du type
    sort << " Ddl_etendu ";
    // les données
    sort << a.ddl_enum_etendu << " " << setprecision(ParaGlob::NbdigdoCA()) << a.val_ddl << " ";
     return sort;      
  };
  
#ifndef MISE_AU_POINT
  inline 
#endif
  // surcharge de l'operator de lecture
istream & operator >> (istream & entree, Ddl_etendu& a)
  { // vérification du type
    string type;
    entree >> type;
    if (type != "Ddl_etendu")
      {cout << "\n **** erreur en lecture d'une grandeur  type Ddl_etendu ";
       Sortie (1);
       return entree;
       }
    // entrée des données  
    entree >> a.ddl_enum_etendu;
    entree >> a.val_ddl;
    
    return entree;      
  };

   

#endif  // fin de l'inclusion totale
