/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*             ********   ***                                 SparseLib++    */
/*          *******  **  ***       ***      ***               v. 1.5c        */
/*           *****      ***     ******** ********                            */
/*            *****    ***     ******** ********              R. Pozo        */
/*       **  *******  ***   **   ***      ***                 K. Remington   */
/*        ********   ********                                 A. Lumsdaine   */
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*                                                                           */
/*                                                                           */
/*                     SparseLib++ : Sparse Matrix Library                   */
/*                                                                           */
/*               National Institute of Standards and Technology              */
/*                        University of Notre Dame                           */
/*              Authors: R. Pozo, K. Remington, A. Lumsdaine                 */
/*                                                                           */
/*                                 NOTICE                                    */
/*                                                                           */
/* Permission to use, copy, modify, and distribute this software and         */
/* its documentation for any purpose and without fee is hereby granted       */
/* provided that the above notice appear in all copies and supporting        */
/* documentation.                                                            */
/*                                                                           */
/* Neither the Institutions (National Institute of Standards and Technology, */
/* University of Notre Dame) nor the Authors make any representations about  */
/* the suitability of this software for any purpose.  This software is       */
/* provided ``as is'' without expressed or implied warranty.                 */
/*                                                                           */
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

// modification GR
//  1) on utilise une interface unique pour tous les préconditionneurs
//     d'où l'héritage d'une classe virtuelle
//  2) on utilise sytématiquement les classes templates MV++

#ifndef ICPRE_GR_H
#define ICPRE_GR_H

//#include "vecdefs.h"
#include "vecdefs_GR.h"   // modif GR
//#include VECTOR_H       // modif GR
#include "compcol_double.h"
#include "comprow_double.h"

#include "pre_cond_double.h"
#include "Mat_abstraite.h"

class ICPreconditioner_double  : public Pre_cond_double
 {

private:
  VECTOR_double val_;
  VECTOR_int    pntr_;
  VECTOR_int    indx_;
  int nz_;
  int dim_[2];

public:
  ICPreconditioner_double(const CompCol_Mat_double &A);
  ICPreconditioner_double(const CompRow_Mat_double &A);
  // cas d'une matrice abstraite
  ICPreconditioner_double(const Mat_abstraite &A);

  // méthodes------
  
  ~ICPreconditioner_double(void){};

  VECTOR_double     solve(const VECTOR_double &x) const;
  VECTOR_double     trans_solve(const VECTOR_double &x) const;
  
//====================== protégée ========================

protected : 
  // fonction interne d'initialisation pour éviter la recopie
  void Init_CompCol_Mat_double(const CompCol_Mat_double &A); 
  void Init_CompRow_Mat_double(const CompRow_Mat_double &A);
  void Init_Mat_creuse_CompCol(const Mat_abstraite &A);
};

#endif
