
// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

/************************************************************************
 *     DATE:        03/02/2003                                          *
 *                                                                $     *
 *     AUTEUR:      G RIO   (mailto:gerardrio56@free.fr)                *
 *                                                                $     *
 *     PROJET:      Herezh++                                            *
 *                                                                $     *
 ************************************************************************
 *     BUT:  Visualisation des isovaleurs en geomview.                  *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *                                                                      *
 *     REMARQUE:  Par rapport aux isovaleurs vrml, c'est                *
 *                uniquement la sortie de la légende qui change.        *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *                                                                      *
 *     VERIFICATION:                                                    *
 *                                                                      *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *     !        !            !                                    !     *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *
 *     MODIFICATIONS:                                                   *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *                                                                $     *
 ************************************************************************/
#ifndef ISOVALEURS_GEOMVIEW_T
#define ISOVALEURS_GEOMVIEW_T

#include "OrdreVisu.h"
#include "spectre.h"
#include "Isovaleurs_vrml.h"

/// @addtogroup Les_sorties_geomview
///  @{
///


class Isovaleurs_geomview : public Isovaleurs_vrml
{
  public :
    // CONSTRUCTEURS :
     // par defaut
     Isovaleurs_geomview () ; 
     
     // constructeur de copie 
     Isovaleurs_geomview (const Isovaleurs_geomview& algo);
               
    // DESTRUCTEUR :
     ~Isovaleurs_geomview () ;  
    
    // METHODES PUBLIQUES :
    
  protected :  
    // VARIABLES PROTEGEES :
    // METHODES PROTEGEES :
    // sortie du dessin de la légende
    void Sortie_dessin_legende(UtilLecture & entreePrinc);

 };
 /// @}  // end of group

#endif  
