
// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

#include "Deformees_maple.h"

#include <iomanip>

    // CONSTRUCTEURS :
// par defaut
Deformees_maple::Deformees_maple () :
   Deformees_vrml("....................parametrisation de la deformee"
             ,"parametrisation de la deformee","de")
   ,amplification(1.)
     {}; 
     
     // constructeur de copie 
Deformees_maple::Deformees_maple (const Deformees_maple& ord) :
    Deformees_vrml(ord) 
   ,amplification(ord.amplification)
      {};
               
    // DESTRUCTEUR :
Deformees_maple::~Deformees_maple () 
     {};  
    
    // METHODES PUBLIQUES :
// execution de l'ordre
// tab_mail : donne les numéros de maillage concerné
// incre : numéro d'incrément qui en cours
// type_incre : indique si c'est le premier le dernier ou l'incrément courant a visualiser ou pas
// animation : indique si l'on est en animation ou pas
void Deformees_maple::ExeOrdre(ParaGlob * ,const Tableau <int>&  ,LesMaillages *,bool , LesReferences*
                      ,LesLoisDeComp* ,DiversStockage*,Charge*,LesCondLim*,LesContacts*
                      ,Resultats*,UtilLecture & ,OrdreVisu::EnumTypeIncre ,int 
                      ,bool ,const map < string, const double * , std::less <string> >&
                      ,const List_io < TypeQuelconque >& listeVecGlob)
 {// visualisation du maillage pointé si actif
  if (actif)
    {};                          
  };

// choix de l'ordre, cet méthode peut entraîner la demande d'informations
// supplémentaires si nécessaire. qui sont ensuite gérer par la classe elle même
void Deformees_maple::ChoixOrdre()
   { // demande de précision
     bool choix_valide = false;
     while (!choix_valide)
      { // tout d'abord on met le choix valide a priori
        choix_valide = true;
        cout << "\n ----> preparation du parametrage des deformees"
             << "\n  parametre par defaut ? : amplification du deplacement = 1. "
             << "   (rep 'o'(defaut)) pour accepter ces parametres sinon autre ";
        string rep;
        cout << "\n reponse ? "; rep = lect_return_defaut(false,"o");
        if (rep != "o") 
          { // choix du facteur d'amplification
            cout << "\n facteur d'amplification : par defaut 1. (rep 'o') ";
            rep = lect_return_defaut(false,"o");
            if (rep != "o")
              { cout << "\n nouvelle valeur du facteur  (un reels ) ?  ";
                amplification=lect_double();
                choix_valide = choix_valide && true;
                }
            else
              { amplification = 1.;
                choix_valide = choix_valide && true;
               }    
            }
         else
            choix_valide = choix_valide && true;  
          }  
       // appel de la méthode de la classe mère
       OrdreVisu::ChoixOrdre();    
     };     
            
                            
