
// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

#include "Fin_maple.h"

#include <iomanip>

    // CONSTRUCTEURS :
// par defaut
Fin_maple::Fin_maple () :
   OrdreVisu(".arret visualisation interactive pour format maple" // de 15 à 65
             ,"met fin a la visualisation interactive pour format maple","f")
     {}; 

     // constructeur de copie 
Fin_maple::Fin_maple (const Fin_maple& ord) :
    OrdreVisu(ord)
      {};
               
    // DESTRUCTEUR :
Fin_maple::~Fin_maple () 
     {};  
    
    // METHODES PUBLIQUES :
         
// lecture des paramètres de l'ordre dans un flux
void Fin_maple::Lecture_parametres_OrdreVisu(UtilLecture & )
//void Fin_maple::Lecture_parametres_OrdreVisu(UtilLecture & entreePrinc)
 { // si dans le flot il existe l'identificateur adoc on lit sinon on passe
/*   if (strstr(entreePrinc.tablcarCVisu,"debut_fin_visualisation")!=NULL)
     {// essaie de lecture
      try 
        { string nom; 
          (*entreePrinc.entCVisu) >> nom ;
          if (nom != "debut_fin_visualisation")
            { cout << "\n Erreur en lecture des parametres de l'ordre d'activation de la fin_visualisation"
                   << " a partir d'un fichier .CVisu,"
                   << " le premier enregistrement doit etre le mot clef: debut_fin_visualisation "
                   << " on ne tiens pas compte  des parametres fournies !! ";
              }
          else
           { // appel de l'ordre de la classe mère
             OrdreVisu::Lect_para_OrdreVisu_general(entreePrinc);
             if (nom != "fin_fin_visualisation")
               { cout << "\n Erreur en lecture des parametres de l'ordre d'activation de la fin_visualisation"
                      << " a partir d'un fichier .CVisu,"
                      << " le dernier enregistrement doit etre le mot clef: fin_fin_visualisation "
                      << " on continue cependant, mais il y a peut-etre un pb !! ";
                }
            }       
         }    
      catch (...)// erreur de lecture
       {  cout << "\n Erreur en lecture des parametres de de l'ordre d'activation de la fin_visualisation"
               << " a partir d'un fichier .CVisu,"
               << " on ne tiens pas compte  des parametres fournies !! ";
          if (ParaGlob::NiveauImpression() >= 4)     
             cout  << "\n Visuali_maple::Lecture_parametres_OrdreVisu(..";
        }
      entreePrinc.NouvelleDonneeCVisu(); // on passe un enregistrement  
      } */
  };

// écriture des paramètres de l'ordre dans un flux
void Fin_maple::Ecriture_parametres_OrdreVisu(UtilLecture & )
//void Fin_maple::Ecriture_parametres_OrdreVisu(UtilLecture & entreePrinc)
 { // récup du flot  
/*   ostream & sort = (*(entreePrinc.Sort_CommandeVisu()));
   // on commente le fonctionnement
   sort << "\n #  ------------------- fin effective de la visualisation: ---------------- "
        << "\n #  facultatif ";
   sort << "\n debut_fin_visualisation #  le mot cle de debut ";
   // appel de l'ordre de la classe mère
   OrdreVisu::Ecrit_para_OrdreVisu_general(entreePrinc);
   // fin      
   sort << "\n fin_fin_visualisation \n"; */   
  };
     
     

                            
