/*! \file Sortie.h
    \brief classes de gestion de l'arrêt d'Herezh
*/

// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

/************************************************************************
 *     DATE:        23/01/97                                            *
 *                                                                $     *
 *     AUTEUR:      G RIO   (mailto:gerardrio56@free.fr)                *
 *                                                                $     *
 *     PROJET:      Herezh++                                            *
 *                                                                $     *
 ************************************************************************
 *     BUT:  Gestion de la fin du programme.                            *
 *                                                                $     *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *
 *                                                                $     *
 ************************************************************************/
#ifndef SORTIE_H
#define SORTIE_H

#include <iostream>
using namespace std;

#include <stdlib.h>

/** @defgroup Classes_gestions_arret_Herezh Classes_gestions_arret_Herezh
*
* \author    Gérard Rio
* \version   1.0
* \date      23/01/97
* \brief       Def gestion de l'arrêt d'Herezh
*
*/

/// @addtogroup Classes_gestions_arret_Herezh
///  @{
///

/**
*
* \brief       gestion d'exception pour Sortie
*
*/
 class ErrSortie
   { public :
       ErrSortie () {} ;  // CONSTRUCTEURS 
       ~ErrSortie () {};// DESTRUCTEUR :
    };
    /// @}  // end of group

    
/// @addtogroup Classes_gestions_arret_Herezh
///  @{

/**
*
* \brief      gestion d'exception pour Sortie finale
*
*/

 class ErrSortieFinale
   { public :
       ErrSortieFinale () {} ;  // CONSTRUCTEURS
       ~ErrSortieFinale () {};// DESTRUCTEUR :
    };
    /// @}  // end of group

    
/// @addtogroup Classes_gestions_arret_Herezh
///  @{
///

/// fonction pour capter un appel à la sortie
void Sortie(int n);
/// @}  // end of group

#endif  
