

// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

#include "CompFrotAbstraite.h"

		// CONSTRUCTEURS :
CompFrotAbstraite::CompFrotAbstraite () :  // Constructeur par defaut
    LoiAbstraiteGeneral(),saveResul(NULL),comp_tangent_simplifie(false)
		 { };
// Constructeur utile si l'identificateur du nom de la loi
// de comportement  et la dimension sont connus		
CompFrotAbstraite::CompFrotAbstraite (Enum_comp id_compor,Enum_categorie_loi_comp id_categorie
                                                          ,int dimension) :
     LoiAbstraiteGeneral(id_compor,dimension,id_categorie)
     ,saveResul(NULL),comp_tangent_simplifie(false)
		{ };
		
// Constructeur utile si l'identificateur du nom de la loi
// de comportement et la dimension sont connus		
CompFrotAbstraite::CompFrotAbstraite (char* nom,Enum_categorie_loi_comp id_categorie
                                                          ,int dimension) :
     LoiAbstraiteGeneral(nom,dimension,id_categorie)
	 ,saveResul(NULL),comp_tangent_simplifie(false)
	 	{ };

// Constructeur de copie
CompFrotAbstraite::CompFrotAbstraite (const CompFrotAbstraite & a ) :
		 LoiAbstraiteGeneral(a),comp_tangent_simplifie(false)
         ,saveResul(a.saveResul->Nevez_SaveResul())
		   {} ;
		
// DESTRUCTEUR VIRTUEL :
CompFrotAbstraite::~CompFrotAbstraite ()
		{ 	};
		
	
// =============== methodes  ======================
		

