// FICHIER : Coordonnee1.cc
// CLASSE : Coordonnee1

// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

// contient que les méthodes qui sont relatives aux méthodes non-inlines

//#include "Debug.h"

# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
#include "ConstMath.h"
#include "MathUtil.h"

#include "Coordonnee1.h"
#include "Vecteur.h"

// Constructeur fonction d'un vecteur qui doit avoir une dim =  1
Coordonnee1::Coordonnee1 ( const Vecteur& vec):
 Coordonnee(1,coord1)
 {  
   #ifdef MISE_AU_POINT
     if (vec.Taille() !=1) 
      { cout << "\n erreur,pour convertir un vecteur en Coordonnee1 il faut que sa "
             << "dimension soit  1, ici elle est : " << vec.Taille() 
             << "\nCoordonnee1::Coordonnee1 (Vecteur& vec)" << endl;
        Sortie (1);
       } 
   #endif
   // copie des coordonnees
   coord1[0]=vec(1);
  };

//  conversion en Vecteur
Vecteur Coordonnee1::Vect() const 
  { return  Vecteur(1,coord); };

