// FICHIER : Coordonnee2H.cp
// CLASSE : Coordonnee2H

// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

// concerne les méthodes qui ne sont pas en include

//#include "Debug.h"

# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
#include "ConstMath.h"
#include "MathUtil.h"

#include "Coordonnee2.h"
#include "Vecteur.h"

// Constructeur fonction d'un vecteur qui doit avoir une dim =  2
Coordonnee2H::Coordonnee2H ( const Vecteur& vec):
 CoordonneeH(2,coord2)
 {  
   #ifdef MISE_AU_POINT
     if (vec.Taille() !=2) 
      { cout << "\n erreur,pour convertir un vecteur en Coordonnee2H il faut que sa "
             << "dimension soit  2, ici elle est : " << vec.Taille() 
             << "\nCoordonnee2H::Coordonnee2H (Vecteur& vec)" << endl;
        Sortie (1);
       } 
   #endif
   // copie des coordonnees
   coord2[0]=vec(1);coord2[1]=vec(2);
  };

//  conversion en Vecteur
Vecteur Coordonnee2H::Vect() const 
  { return Vecteur(dim,coord); };

